ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.10 by root, Mon Mar 12 14:47:53 2007 UTC vs.
Revision 1.53 by root, Sun Aug 19 09:27:08 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
24use Digest::MD5; 26use Digest::MD5;
27use Carp;
28use Coro::Channel;
29use Coro::Storable; $Storable::canonical = 1;
30
31$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 32
26sub usage { 33sub usage {
27 warn <<EOF; 34 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 35Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 36 [--install-arch path]
41my $CACHE = 0; 48my $CACHE = 0;
42my $FORCE; 49my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 50my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 51my $TMPFILE = "aaaa0";
45 52
53our %COLOR = (
54 black => 0,
55 white => 1,
56 navy => 2,
57 red => 3,
58 orange => 4,
59 blue => 5,
60 darkorange => 6,
61 green => 7,
62 lightgreen => 8,
63 grey => 9,
64 brown => 10,
65 gold => 11,
66 tan => 12,
67);
68
46END { system "rm", "-rf", $TMPDIR } 69END { system "rm", "-rf", $TMPDIR }
47 70
48Event->signal (signal => "INT", cb => sub { exit 1 }); 71Event->signal (signal => "INT", cb => sub { exit 1 });
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 72Event->signal (signal => "TERM", cb => sub { exit 1 });
50 73
67} 90}
68 91
69sub inst_maps($) { 92sub inst_maps($) {
70 my (undef, $path) = @_; 93 my (undef, $path) = @_;
71 94
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 95 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 96
74 if (!-f "$path/regions") { 97 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 98 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 99 exit 1 unless $FORCE;
77 } 100 }
78 101
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 102 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
103 and die "map installation failed.\n";
104
105 print "maps installed successfully.\n";
80} 106}
81 107
82{ 108{
83 our %PNG32; 109 our %ANIMINFO;
84 our %FACEINFO; 110 our %FACEINFO;
111 our %RESOURCE;
85 our @ARC; 112 our @ARC;
113 our %ARC;
114 our $TRS;
86 our $NFILE; 115 our $NFILE;
87 our %ANIM; 116 our $PATH;
88 117
89 our (@png, @trs, @arc); # files we are interested in 118 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 119
120 our $c_arc = new Coro::Channel;
121 our $c_trs = new Coro::Channel;
122 our $c_res = new Coro::Channel;
123
124 our @c_png;
125
91 sub commit_png { 126 sub commit_png($$$) {
92 my ($name, $data) = @_; 127 my ($name, $data, $T) = @_;
93 128
94 $PNG32{$name} = $data; 129 $FACEINFO{$name}{"data$T"} = $data;
95 $FACEINFO{$name} ||= {};
96 } 130 }
97 131
98 sub process_png { 132 sub process_png {
99 while (@png) { 133 while (@c_png) {
100 my $path = pop @png; 134 my ($path, $delete) = @{pop @c_png};
101 135
102 my $png; 136 my $png;
103 aio_lstat $path; 137 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 138 my ($size, $mtime) = (stat _)[7,9];
105 139
106 if (0 > aio_load $path, $png) { 140 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 141 warn "$path: $!, skipping.\n";
108 next; 142 next;
109 } 143 }
110 144
145 my $stem = $path;
146 my $T;
147
148 if ($stem =~ s/\.32x32\.png~?$//) {
149 $T = 32;
150 } elsif ($stem =~ s/\.64x64\.png~?$//) {
151 $T = 64;
152 } else {
153 warn "$path: weird filename, skipping.\n";
154 next;
155 }
156
111 # quickly extract width and height of the (necessarily PNG) image 157 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 158 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 159 warn "$path: not a recognized png file, skipping.\n";
114 next; 160 next;
115 } 161 }
116 162
117 my ($w, $h) = unpack "NN", $1; 163 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 164
127 if ($w < $T || $h < $T) { 165 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 166 warn "$path: too small ($w $h), skipping.\n";
129 next; 167 next;
130 } 168 }
132 if ($w % $T || $h % $T) { 170 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 171 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 172 next;
135 } 173 }
136 174
175 unless ($path =~ /~$/) {
176 # possibly enlarge
177 if (0 > aio_stat "$stem.64x64.png") {
178 my $other = "$stem.64x64.png~";
179
180 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
181 fork_sub {
182 my $CROP;
183 my $SRC = "png:\Q$path\E";
184
185 # check if this is a wall. ultra-ugly. ultra-ultra-ugly.
186 if ($path =~ /^(.*\/wall\/.*_)([0-9A-F])(\.x11.*\.png)$/) {
187 my ($pfx, $dir, $sfx) = ($1, hex $2, $3);
188 #check for 0..F images to be sure(?) this is a wall
189 unless (grep { !-e sprintf "%s%X%s", $pfx, $_, $sfx } 0..15) {
190 # add a 4px border and add other images around it
191 $CROP = "-shave 8x8 +repage";
192
193 $w += 8;
194 $h += 8;
195
196 $SRC = "-size ${w}x${h} xc:transparent";
197 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
198
199 # 8 surrounding images
200 for (
201 # x y b r0 r1
202 [-1, -1, 0, 6],
203 [ 0, -1, 1, 10, 14],
204 [+1, -1, 0, 12],
205
206 [-1, 0, 8, 5, 7],
207 #
208 [+1, 0, 2, 5, 13],
209
210 [-1, +1, 0, 3],
211 [ 0, +1, 4, 10, 11],
212 [+1, +1, 0, 9],
213 ) {
214 my ($x, $y, $d, $r0, $r1) = @$_;
215 $SRC .= sprintf " png:%s%X%s -geometry %+d%+d -composite",
216 "\Q$pfx",
217 ($dir & $d) ? $r1 : $r0,
218 "\Q$sfx",
219 $x * ($w - 8) + 4,
220 $y * ($h - 8) + 4;
221 }
222 }
223 }
224
225 system "convert -depth 8 $SRC rgba:-"
226 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
227 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
228 and die "convert/cfhq2xa pipeline error: status $? ($!)";
229 system $OPTIPNG, "-i0", "-q", "$other~";
230 die "$other~ has zero size, aborting." unless -s "$other~";
231 rename "$other~", $other;
232 };
233 }
234
235 push @c_png, [$other, !$CACHE];
236 }
237
238 # possibly scale down
239 if (0 > aio_stat "$stem.32x32.png") {
240 my $other = "$stem.32x32.png~";
241
242 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
243 fork_sub {
244 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
245 system $OPTIPNG, "-i0", "-q", "$other~";
246
247 # reduce smoothfaces >10000 bytes
248 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
249 my $ncolor = 256;
250 while () {
251 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
252 system $OPTIPNG, "-i0", "-q", "$other~~";
253 last if 10000 > -s "$other~~";
254 $ncolor = int $ncolor * 0.9;
255 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
256 }
257
258 printf "reduced %s from %d to %d bytes using %d colours.\n",
259 $other, -s "$other~", -s "$other~~", $ncolor
260 if $VERBOSE >= 2;
261 rename "$other~~", "$other~";
262 }
263
264 die "$other~ has zero size, aborting." unless -s "$other~";
265 rename "$other~", $other;
266 };
267 }
268
269 #warn "scaled down $path to $other\n";#d#
270 push @c_png, [$other, !$CACHE];
271 }
272 }
273
274 (my $face = $stem) =~ s/^.*\///;
275
276 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 277 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 278 # split
139 my @tile; 279 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 280 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 281 for my $y (0 .. (int $h / $T) - 1) {
155 ( 295 (
156 "(", 296 "(",
157 "+clone", 297 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 298 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 299 "+repage",
300 -quality => "00",
160 -write => "png:$_->[2]~", 301 -write => "png32:$_->[2]~",
161 "+delete", 302 "+delete",
162 ")", 303 ")",
163 ) 304 )
164 } @todo), 305 } @todo),
165 "null:"; 306 "null:";
169 close $convert; 310 close $convert;
170 311
171 # pass 2, optimise, and rename 312 # pass 2, optimise, and rename
172 for (@todo) { 313 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 314 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
315 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 316 rename "$_->[2]~", $_->[2];
175 } 317 }
176 }; 318 };
177 } 319 }
178 320
182 324
183 if (0 > aio_load $file, $tile) { 325 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 326 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 327 }
186 IO::AIO::aio_unlink $file unless $CACHE; 328 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 329 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 330 }
189 } else { 331 } else {
190 # use as-is (either small, use smooth) 332 # use as-is (either small, use smooth)
191 commit_png $face, $png; 333 commit_png $face, $png, $T;
192 } 334 }
335
336 aio_unlink $path if $delete;
193 } 337 }
194 } 338 }
195 339
196 sub process_arc { 340 sub process_arc {
197 while (@arc) { 341 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 342 my ($dir, $file) = @$job;
199 343
200 my $arc; 344 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 345 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 346
203 my $arc = read_arch "$dir/$file"; 347 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 348 for my $o (values %$arc) {
205 push @ARC, $o; 349 push @ARC, $o;
350 for (my $m = $o; $m; $m = $m->{more}) {
351 $ARC{$m->{_name}} = $m;
352 }
206 353
207 $o->{editor_folder} = $dir; 354 $o->{editor_folder} = $dir;
208 355
209 my $visibility = delete $o->{visibility}; 356 my $visibility = delete $o->{visibility};
210 my $magicmap = delete $o->{magicmap}; 357 my $magicmap = delete $o->{magicmap};
221 my $x = $o->{x} - $dx; 368 my $x = $o->{x} - $dx;
222 my $y = $o->{y} - $dy; 369 my $y = $o->{y} - $dy;
223 370
224 my $ext = $x|$y ? "+$x+$y" : ""; 371 my $ext = $x|$y ? "+$x+$y" : "";
225 372
226 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 373 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
227 374
228 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 375 $visibility = delete $o->{visibility} if exists $o->{visibility};
229 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 376 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
230 377
231 my $anim = delete $o->{anim}; 378 my $anim = delete $o->{anim};
232 379
233 if ($anim) { 380 if ($anim) {
381 # possibly add $ext to the animation name to avoid
382 # the need to specify archnames for all parts
383 # of a multipart archetype.
234 $o->{animation} = "$o->{_name}"; 384 $o->{animation} = "$o->{_name}";
385 my $facings = 1;
386 my @frames;
235 387
236 for (@$anim) { 388 for (@$anim) {
237 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 389 if (/^facings\s+(\d+)/) {
390 $facings = $1*1;
391 } elsif (/^blank.x11$|^empty.x11$/) {
392 push @frames, $_;
393 } else {
394 push @frames, "$_$ext";
395 }
238 } 396 }
239 397
240 $ANIM{"$o->{_name}$ext"} = 398 $ANIMINFO{$o->{animation}} = {
241 join "", map "$_\n", 399 facings => $facings,
242 "anim $o->{_name}", 400 frames => \@frames,
243 @$anim, 401 };
244 "mina";
245 } 402 }
246 403
247 for my $face ($o->{face} || (), @{$anim || []}) { 404 for my $face ($o->{face} || (), @{$anim || []}) {
248 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 405 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
249 406
250 my $info = $FACEINFO{$face} ||= {}; 407 my $info = $FACEINFO{$face} ||= {};
251 408
409 $info->{arc} = $o;
252 $info->{visibility} = $visibility if defined $visibility; 410 $info->{visibility} = $visibility if defined $visibility;
253 $info->{magicmap} = $magicmap if defined $magicmap; 411 $info->{magicmap} = $magicmap if defined $magicmap;
254 } 412 }
413
414 if (my $smooth = delete $o->{smoothface}) {
415 my %kv =split /\s+/, $smooth;
416 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
417 while (my ($face, $smooth) = each %kv) {
418 $FACEINFO{$face}{smooth} = $smooth;
419 $FACEINFO{$face}{smoothlevel} = $level;
420 }
421 }
255 } 422 }
256 } 423 }
257 } 424 }
258 } 425 }
259 426
260 sub process_trs { 427 sub process_trs {
261 while (@trs) { 428 while (my $job = $c_trs->get) {
262 my ($dir, $file) = @{pop @trs}; 429 my ($dir, $file) = @$job;
430 my $path = "$dir/$file";
431
432 my $trs;
433 if (0 > aio_load $path, $trs) {
434 warn "$path: $!, skipping.\n";
435 next;
436 }
437
438 $TRS .= $trs;
439 }
440 }
441
442 my %FILECACHE;
443
444 sub load_cached($;$) {
445 unless (exists $FILECACHE{$_[0]}) {
446 my $data;
447 if (0 < aio_load $_[0], $data) {
448 if ($_[1]) {
449 $data = eval { $_[1]->($data) };
450 warn "$_[0]: $@" if $@;
451 }
452 }
453
454 $FILECACHE{$_[0]} = $data;
455 }
456
457 $FILECACHE{$_[0]}
458 }
459
460 sub process_res {
461 while (my $job = $c_res->get) {
462 my ($dir, $file, $type) = @$job;
463
464 my $data;
465 aio_load "$dir/$file", $data;
466
467 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
468
469 next if $meta && !exists $meta->{$file};
470
471 $meta = {
472 %{ $meta->{"" } || {} },
473 %{ $meta->{$file} || {} },
474 };
475
476 if ($meta->{license} =~ s/^#//) {
477 $meta->{license} = ({
478 "pd" => "Public Domain",
479 "gpl" => "GNU General Public License, version 3.0 or any later",
480 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
481 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
482 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
483 })->{$meta->{license}}
484 || warn "$dir/$file: license tag '$meta->{license}' not found.";
485 }
486
487 $file =~ s/\.res$//;
488 $file =~ s/\.(ogg|wav|jpg|png)$//;
489
490 substr $dir, 0, 1 + length $PATH, "";
491
492 $RESOURCE{"$dir/$file"} = {
493 type => (delete $meta->{type}) || $type,
494 data => $data,
495 chksum => (Digest::MD5::md5 $data),
496 %$meta ? (meta => $meta) : (),
497 };
263 } 498 }
264 } 499 }
265 500
266 sub find_files; 501 sub find_files;
267 sub find_files { 502 sub find_files {
272 my ($dirs, $nondirs) = @_; 507 my ($dirs, $nondirs) = @_;
273 508
274 find_files "$path/$_" 509 find_files "$path/$_"
275 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 510 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
276 511
512 my $dir = $path;
513 substr $dir, 0, 1 + length $PATH, "";
514
277 for my $file (@$nondirs) { 515 for my $file (@$nondirs) {
516 if ($dir =~ /^music(?:\/|$)/) {
517 $c_res->put ([$path, $file, 3]) # FT_MUSIC
518 if $file =~ /\.(ogg)$/;
519
520 } elsif ($dir =~ /^sound(?:\/|$)/) {
521 $c_res->put ([$path, $file, 5]) # FT_SOUND
522 if $file =~ /\.(wav|ogg)$/;
523
524 } elsif ($dir =~ /^res(?:\/|$)/) {
525 $c_res->put ([$path, $file, 0]) # FT_FACE
526 if $file =~ /\.(jpg|png)$/;
527 $c_res->put ([$path, $file, 7]) # FT_RSRC
528 if $file =~ /\.(res)$/;
529
278 if ($file =~ /\.png$/) { 530 } elsif ($file =~ /\.png$/) {
279 push @png, "$path/$file"; 531 push @c_png, ["$path/$file", 0];
532
280 } elsif ($file =~ /\.trs$/) { 533 } elsif ($file =~ /\.trs$/) {
281 push @trs, [$path, $file]; 534 $c_trs->put ([$path, $file]);
535
282 } elsif ($file =~ /\.arc$/) { 536 } elsif ($file =~ /\.arc$/) {
283 push @arc, [$path, $file]; 537 $c_arc->put ([$path, $file]);
538
284 } else { 539 } else {
285 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 540 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
286 } 541 }
287 } 542 }
288 }; 543 };
289 } 544 }
290 545
291 sub inst_arch($) { 546 sub inst_arch($) {
292 my (undef, $path) = @_; 547 my (undef, $path) = @_;
293 548
549 $PATH = $path;
550
551 print "\n",
294 print "installing '$path' to '$DATADIR'\n\n"; 552 "Installing '$path' to '$DATADIR'\n",
553 "\n",
554 "This can take a long time if you run this\n",
555 "for the first time or do not use --cache.\n",
556 "\n",
557 "Unless you run verbosely, all following warning\n",
558 "or error messages indicate serious problems.\n",
559 "\n";
295 560
296 if (!-d "$path/treasures") { 561 if (!-d "$path/treasures") {
297 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 562 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
298 exit 1 unless $FORCE; 563 exit 1 unless $FORCE;
299 } 564 }
300 565
566 print "scanning files...\n" if $VERBOSE;
567
301 find_files $path; 568 find_files $path;
569
570 my @a_arc = map +(async \&process_arc), 1..2;
571 my @a_res = map +(async \&process_res), 1..2;
572 my @a_trs = map +(async \&process_trs), 1..2;
573
302 IO::AIO::flush; 574 IO::AIO::flush;
303 575
304 $_->join for ( 576 $c_res->put (undef) for @a_res;
305 (async \&process_png), (async \&process_png), 577 $c_arc->put (undef) for @a_arc;
306 (async \&process_trs), (async \&process_trs), 578 $c_trs->put (undef) for @a_trs;
307 (async \&process_arc), (async \&process_arc),
308 );
309 579
580 print "start file scan, arc, res processing...\n" if $VERBOSE;
581
582 $_->join for @a_arc; # need to parse all archetypes before png processing
583
584 print "end arc, start png processing...\n" if $VERBOSE;
585
586 # four png crunchers work fine for my 2x smp machine
587 my @a_png = map +(async \&process_png), 1..4;
588
589 $_->join for (@a_trs, @a_res, @a_png);
590
591 print "scanning done, processing results...\n" if $VERBOSE;
310 { 592 {
311 open my $fh, ">:utf8", "$DATADIR/animations~" 593 # remove path prefix from editor_folder
312 or die "$DATADIR/animations~: $!"; 594 substr $_->{editor_folder}, 0, 1 + length $path, ""
313 print $fh join "", map $ANIM{$_}, sort keys %ANIM 595 for values %ARC;
596
597 print "resolving inheritance tree...\n" if $VERBOSE;
598 # resolve inherit
599 while () {
600 my $progress;
601 my $loop;
602
603 for my $o (values %ARC) {
604 if (my $other = $o->{inherit}) {
605 if (my $s = $ARC{$other}) {
606 if ($s->{inherit}) {
607 $loop = $s;
608 } else {
609 delete $o->{inherit};
610 my %s = %$s;
611 delete @s{qw(_name more name name_pl)};
612 %$o = ( %s, %$o );
613 ++$progress;
614 }
615 } else {
616 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
617 delete $ARC{$o->{_name}};
618 }
619 }
620 }
621
622 unless ($progress) {
623 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
624 if $loop;
625
626 last;
627 }
314 } 628 }
315 629
316 { 630 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
631 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
632
633 print "writing archetypes...\n" if $VERBOSE;
317 open my $fh, ">:utf8", "$DATADIR/archetypes~" 634 open my $fh, ">:utf8", "$DATADIR/archetypes~"
318 or die "$DATADIR/archetypes~: $!"; 635 or die "$DATADIR/archetypes~: $!";
319 substr $_->{editor_folder}, 0, length $path, "" for @ARC; 636 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
320 print $fh Crossfire::archlist_to_string \@ARC;
321 } 637 }
322 638
323 { 639 {
640 print "writing treasures...\n" if $VERBOSE;
641 open my $fh, ">:utf8", "$DATADIR/treasures~"
642 or die "$DATADIR/treasures~: $!";
643 print $fh $TRS;
644 }
645
646 {
647 print "processing facedata...\n" if $VERBOSE;
324 while (my ($k, $v) = each %FACEINFO) { 648 while (my ($k, $v) = each %FACEINFO) {
325 $v->{data32} ||= delete $PNG32{$k}; 649 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
326 }
327
328 while (my ($k, $v) = each %FACEINFO) {
329 length $v->{data32} or warn "$k: face has no png32. this will crash the server.\n"; 650 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
651
652 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
653 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
330 654
331 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 655 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
656 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
657
658 if (my $magicmap = $v->{magicmap}) {
659 $magicmap =~ y/A-Z_\-/a-z/d;
660 $v->{magicmap} = $COLOR{$magicmap};
332 } 661 }
333 662
663 delete $v->{arc};
664 }
665
666 print "writing facedata...\n" if $VERBOSE;
334 open my $fh, ">:perlio", "$DATADIR/faces~" 667 open my $fh, ">:perlio", "$DATADIR/facedata~"
335 or die "$DATADIR/faces~: $!"; 668 or die "$DATADIR/facedata~: $!";
336 669
337 print $fh Storable::nfreeze \%FACEINFO; 670 print $fh freeze {
338 671 version => 2,
339 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 672 faceinfo => \%FACEINFO,
673 animinfo => \%ANIMINFO,
674 resource => \%RESOURCE,
340 } 675 };
676 }
341 677
678 print "committing files...\n" if $VERBOSE;
679
342 for (qw(archetypes faces animations)) { 680 for (qw(archetypes facedata treasures)) {
343 chmod 0644, "$DATADIR/$_~"; 681 chmod 0644, "$DATADIR/$_~";
344 rename "$DATADIR/$_~", "$DATADIR/$_"; 682 rename "$DATADIR/$_~", "$DATADIR/$_"
683 or die "$DATADIR/$_: $!";
345 } 684 }
346 685
347 die "--install-arch not fully implemented\n"; 686 print "archetype data installed successfully.\n";
348 } 687 }
349} 688}
350 689
351Getopt::Long::Configure ("bundling", "no_ignore_case"); 690Getopt::Long::Configure ("bundling", "no_ignore_case");
352GetOptions ( 691GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines